boolean state = false;
boolean valid = false;
boolean new_ = false;
boolean newline = false;

unsigned long time_stop;
int pulse_time;

int time_pulse = 3;
int time_on = 10;
int time_off = 15;
int time_new = 20;
int time_newline = 25;

int time_diff = 2;

boolean RX_buffer[8];
char RX_char;
int buffer_counter;

//------TX------
const int message_len = 12;
char inputChar[message_len] = "Hello World!";


void setup() {
Serial.begin(9600);
pinMode(4, OUTPUT);
pinMode(2, INPUT_PULLUP);
attachInterrupt(digitalPinToInterrupt(2), stop_time, FALLING);
}

int x = 0;
void loop() {

  digitalWrite(4, HIGH);  
  delay(time_new);                       
  digitalWrite(4, LOW);    
  delay(time_pulse);

  for ( uint8_t bitMask = 128; bitMask != 0; bitMask = bitMask >> 1 ) {
    digitalWrite(4, HIGH);
    if ( inputChar[x] & bitMask ) {
      delay(time_on); 
    } else {
      delay(time_off);
    }
    digitalWrite(4, LOW);    
    delay(time_pulse);
  }
  x++;
  if(x > message_len){
    x=0;
    digitalWrite(4, HIGH);  
    delay(time_newline);                       
    digitalWrite(4, LOW);    
    delay(time_pulse);
  }
}

void stop_time(){
  
    pulse_time = millis() - time_stop;
    if(pulse_time > time_diff){
       valid = false;
       new_ = false;
       newline = false;
       if(pulse_time <= time_on + time_diff && pulse_time >= time_on - time_diff)state = true, valid = true;
       if(pulse_time <= time_off + time_diff && pulse_time >= time_off - time_diff)state = false, valid = true;
       if(pulse_time <= time_new + time_diff && pulse_time >= time_new - time_diff)new_ = true;
       if(pulse_time <= time_newline + time_diff && pulse_time >= time_newline - time_diff)newline = true;
       
       if(valid){
         if(buffer_counter > 8)buffer_counter = 0;
         RX_buffer[buffer_counter] = state;
         buffer_counter++;
       }

       if(new_){
        RX_char = 0;
        for(int i = 0; i<8;i++){
          RX_char |= RX_buffer[7-i] << i;
        }
        Serial.print(RX_char);
        buffer_counter = 0;
       }

       if(newline){
        Serial.println("");
       }
    }
    time_stop = millis();
}

